Index: trunk/client/modules/Elezioni/grafici/jpgraph_pie.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/jpgraph_pie.php	(revision 264)
+++ trunk/client/modules/Elezioni/grafici/jpgraph_pie.php	(revision 265)
@@ -1215,232 +1237,258 @@
 //===================================================
 // CLASS PieGraph
-// Description: 
+// Description:
 //===================================================
 class PieGraph extends Graph {
-    private $posx, $posy, $radius;		
-    private $legends=array();	
+    private $posx, $posy, $radius;
+    private $legends=array();
     public $plots=array();
     public $pieaa = false ;
-//---------------
-// CONSTRUCTOR
-    function PieGraph($width=300,$height=200,$cachedName="",$timeout=0,$inline=1) {
-	$this->Graph($width,$height,$cachedName,$timeout,$inline);
-	$this->posx=$width/2;
-	$this->posy=$height/2;
-	$this->SetColor(array(255,255,255));		
-    }
-
-//---------------
-// PUBLIC METHODS	
+    //---------------
+    // CONSTRUCTOR
+    function __construct($width=300,$height=200,$cachedName="",$timeout=0,$inline=1) {
+        parent::__construct($width,$height,$cachedName,$timeout,$inline);
+        $this->posx=$width/2;
+        $this->posy=$height/2;
+        $this->SetColor(array(255,255,255));
+
+        if ($this->graph_theme) {
+          $this->graph_theme->ApplyGraph($this);
+        }
+    }
+
+    //---------------
+    // PUBLIC METHODS
     function Add($aObj) {
 
-	if( is_array($aObj) && count($aObj) > 0 )
-	    $cl = $aObj[0];
-	else
-	    $cl = $aObj;
-
-	if( $cl instanceof Text ) 
-	    $this->AddText($aObj);
-	elseif( class_exists('IconPlot',false) && ($cl instanceof IconPlot) ) 
-	    $this->AddIcon($aObj);
-	else {
-	    if( is_array($aObj) ) {
-		$n = count($aObj);
-		for($i=0; $i < $n; ++$i ) {
-		    $this->plots[] = $aObj[$i];
-		}
-	    }
-	    else {
-		$this->plots[] = $aObj;
-	    }
-	}
+        if( is_array($aObj) && count($aObj) > 0 )
+        $cl = $aObj[0];
+        else
+        $cl = $aObj;
+
+        if( $cl instanceof Text )
+        $this->AddText($aObj);
+        elseif( class_exists('IconPlot',false) && ($cl instanceof IconPlot) )
+        $this->AddIcon($aObj);
+        else {
+            if( is_array($aObj) ) {
+                $n = count($aObj);
+                for($i=0; $i < $n; ++$i ) {
+                    //if ($aObj[$i]->theme) {
+                    //    $this->ClearTheme();
+                    //}
+                    $this->plots[] = $aObj[$i];
+                }
+            }
+            else {
+                //if ($aObj->theme) {
+                //    $this->ClearTheme();
+                //}
+                $this->plots[] = $aObj;
+            }
+        }
+
+        if ($this->graph_theme) {
+            $this->graph_theme->SetupPlot($aObj);
+            if ($aObj->is_using_plot_theme) {
+                $aObj->UsePlotThemeColors();
+            }
+        }
     }
 
     function SetAntiAliasing($aFlg=true) {
-	$this->pieaa = $aFlg;
-    }
-	
+        $this->pieaa = $aFlg;
+    }
+
     function SetColor($c) {
-	$this->SetMarginColor($c);
+        $this->SetMarginColor($c);
     }
 
 
     function DisplayCSIMAreas() {
-	    $csim="";
-	    foreach($this->plots as $p ) {
-		$csim .= $p->GetCSIMareas();
-	    }
-	    //$csim.= $this->legend->GetCSIMareas();
-	    if (preg_match_all("/area shape=\"(\w+)\" coords=\"([0-9\, ]+)\"/", $csim, $coords)) {
-		$this->img->SetColor($this->csimcolor);
-		$n = count($coords[0]);
-		for ($i=0; $i < $n; $i++) {
-		    if ($coords[1][$i]=="poly") {
-			preg_match_all('/\s*([0-9]+)\s*,\s*([0-9]+)\s*,*/',$coords[2][$i],$pts);
-			$this->img->SetStartPoint($pts[1][count($pts[0])-1],$pts[2][count($pts[0])-1]);
-			$m = count($pts[0]);
-			for ($j=0; $j < $m; $j++) {
-			    $this->img->LineTo($pts[1][$j],$pts[2][$j]);
-			}
-		    } else if ($coords[1][$i]=="rect") {
-			$pts = preg_split('/,/', $coords[2][$i]);
-			$this->img->SetStartPoint($pts[0],$pts[1]);
-			$this->img->LineTo($pts[2],$pts[1]);
-			$this->img->LineTo($pts[2],$pts[3]);
-			$this->img->LineTo($pts[0],$pts[3]);
-			$this->img->LineTo($pts[0],$pts[1]);
-						
-		    }
-		}
-	    }
+        $csim="";
+        foreach($this->plots as $p ) {
+            $csim .= $p->GetCSIMareas();
+        }
+        
+        $csim.= $this->legend->GetCSIMareas();
+        if (preg_match_all("/area shape=\"(\w+)\" coords=\"([0-9\, ]+)\"/", $csim, $coords)) {
+            $this->img->SetColor($this->csimcolor);
+            $n = count($coords[0]);
+            for ($i=0; $i < $n; $i++) {
+                if ($coords[1][$i]=="poly") {
+                    preg_match_all('/\s*([0-9]+)\s*,\s*([0-9]+)\s*,*/',$coords[2][$i],$pts);
+                    $this->img->SetStartPoint($pts[1][count($pts[0])-1],$pts[2][count($pts[0])-1]);
+                    $m = count($pts[0]);
+                    for ($j=0; $j < $m; $j++) {
+                        $this->img->LineTo($pts[1][$j],$pts[2][$j]);
+                    }
+                } else if ($coords[1][$i]=="rect") {
+                    $pts = preg_split('/,/', $coords[2][$i]);
+                    $this->img->SetStartPoint($pts[0],$pts[1]);
+                    $this->img->LineTo($pts[2],$pts[1]);
+                    $this->img->LineTo($pts[2],$pts[3]);
+                    $this->img->LineTo($pts[0],$pts[3]);
+                    $this->img->LineTo($pts[0],$pts[1]);
+
+                }
+            }
+        }
     }
 
     // Method description
     function Stroke($aStrokeFileName="") {
-	// If the filename is the predefined value = '_csim_special_'
-	// we assume that the call to stroke only needs to do enough
-	// to correctly generate the CSIM maps.
-	// We use this variable to skip things we don't strictly need
-	// to do to generate the image map to improve performance
-	// a best we can. Therefor you will see a lot of tests !$_csim in the
-	// code below.
-	$_csim = ($aStrokeFileName===_CSIM_SPECIALFILE);
-
-	// We need to know if we have stroked the plot in the
-	// GetCSIMareas. Otherwise the CSIM hasn't been generated
-	// and in the case of GetCSIM called before stroke to generate
-	// CSIM without storing an image to disk GetCSIM must call Stroke.
-	$this->iHasStroked = true;
-
-	$n = count($this->plots);
-
-	if( $this->pieaa ) {
-
-	    if( !$_csim ) {
-		if( $this->background_image != "" ) {
-		    $this->StrokeFrameBackground();		
-		}
-		else {
-		    $this->StrokeFrame();		
-		    $this->StrokeBackgroundGrad();
-		}
-	    }
-
-
-	    $w = $this->img->width;
-	    $h = $this->img->height;
-	    $oldimg = $this->img->img;
-
-	    $this->img->CreateImgCanvas(2*$w,2*$h);
-	    
-	    $this->img->SetColor( $this->margin_color );
-	    $this->img->FilledRectangle(0,0,2*$w-1,2*$h-1);
-
-	    // Make all icons *2 i size since we will be scaling down the
-	    // imahe to do the anti aliasing
-	    $ni = count($this->iIcons);
-	    for($i=0; $i < $ni; ++$i) {
-		$this->iIcons[$i]->iScale *= 2 ;
-		if( $this->iIcons[$i]->iX > 1 ) 
-		    $this->iIcons[$i]->iX *= 2 ;
-		if( $this->iIcons[$i]->iY > 1 ) 
-		    $this->iIcons[$i]->iY *= 2 ;
-	    }
-
-	    $this->StrokeIcons();
-
-	    for($i=0; $i < $n; ++$i) {
-		if( $this->plots[$i]->posx > 1 ) 
-		    $this->plots[$i]->posx *= 2 ;
-		if( $this->plots[$i]->posy > 1 ) 
-		    $this->plots[$i]->posy *= 2 ;
-
-		$this->plots[$i]->Stroke($this->img,1);
-
-		if( $this->plots[$i]->posx > 1 ) 
-		    $this->plots[$i]->posx /= 2 ;
-		if( $this->plots[$i]->posy > 1 ) 
-		    $this->plots[$i]->posy /= 2 ;
-	    }
-
-	    $indent = $this->doframe ? ($this->frame_weight + ($this->doshadow ? $this->shadow_width : 0 )) : 0 ;
-	    $indent += $this->framebevel ? $this->framebeveldepth + 1 : 0 ;
-	    $this->img->CopyCanvasH($oldimg,$this->img->img,$indent,$indent,$indent,$indent,
-				    $w-2*$indent,$h-2*$indent,2*($w-$indent),2*($h-$indent));
-
-	    $this->img->img = $oldimg ;
-	    $this->img->width = $w ;
-	    $this->img->height = $h ;
-
-	    for($i=0; $i < $n; ++$i) {
-		$this->plots[$i]->Stroke($this->img,2); // Stroke labels
-		$this->plots[$i]->Legend($this);
-	    }
-
-	}
-	else {
-
-	    if( !$_csim ) {
-		if( $this->background_image != "" ) {
-		    $this->StrokeFrameBackground();		
-		}
-		else {
-		    $this->StrokeFrame();		
-		}
-	    }
-
-	    $this->StrokeIcons();
-
-	    for($i=0; $i < $n; ++$i) {
-		$this->plots[$i]->Stroke($this->img);
-		$this->plots[$i]->Legend($this);
-	    }
-	}
-
-	$this->legend->Stroke($this->img);
-	$this->footer->Stroke($this->img);
-	$this->StrokeTitles();
-
-	if( !$_csim ) {	
-
-	    // Stroke texts
-	    if( $this->texts != null ) {
-		$n = count($this->texts);
-		for($i=0; $i < $n; ++$i ) {
-		    $this->texts[$i]->Stroke($this->img);
-		}
-	    }
-
-	    if( _JPG_DEBUG ) {
-		$this->DisplayCSIMAreas();
-	    }
-
-	    // Should we do any final image transformation
-	    if( $this->iImgTrans ) {
-		if( !class_exists('ImgTrans',false) ) {
-		    require_once('jpgraph_imgtrans.php');
-		    //JpGraphError::Raise('In order to use image transformation you must include the file jpgraph_imgtrans.php in your script.');
-		}
-	       
-		$tform = new ImgTrans($this->img->img);
-		$this->img->img = $tform->Skew3D($this->iImgTransHorizon,$this->iImgTransSkewDist,
-						 $this->iImgTransDirection,$this->iImgTransHighQ,
-						 $this->iImgTransMinSize,$this->iImgTransFillColor,
-						 $this->iImgTransBorder);
-	    }
-
-
-	    // If the filename is given as the special "__handle"
-	    // then the image handler is returned and the image is NOT
-	    // streamed back
-	    if( $aStrokeFileName == _IMG_HANDLER ) {
-		return $this->img->img;
-	    }
-	    else {
-		// Finally stream the generated picture					
-		$this->cache->PutAndStream($this->img,$this->cache_name,$this->inline,
-					   $aStrokeFileName);		
-	    }
-	}
+
+        // If the filename is the predefined value = '_csim_special_'
+        // we assume that the call to stroke only needs to do enough
+        // to correctly generate the CSIM maps.
+        // We use this variable to skip things we don't strictly need
+        // to do to generate the image map to improve performance
+        // a best we can. Therefor you will see a lot of tests !$_csim in the
+        // code below.
+        $_csim = ($aStrokeFileName===_CSIM_SPECIALFILE);
+
+        // If we are called the second time (perhaps the user has called GetHTMLImageMap()
+        // himself then the legends have alsready been populated once in order to get the
+        // CSIM coordinats. Since we do not want the legends to be populated a second time
+        // we clear the legends
+        $this->legend->Clear();
+
+        // We need to know if we have stroked the plot in the
+        // GetCSIMareas. Otherwise the CSIM hasn't been generated
+        // and in the case of GetCSIM called before stroke to generate
+        // CSIM without storing an image to disk GetCSIM must call Stroke.
+        $this->iHasStroked = true;
+
+        $n = count($this->plots);
+
+        if( $this->pieaa ) {
+
+            if( !$_csim ) {
+                if( $this->background_image != "" ) {
+                    $this->StrokeFrameBackground();
+                }
+                else {
+                    $this->StrokeFrame();
+                    $this->StrokeBackgroundGrad();
+                }
+            }
+
+
+            $w = $this->img->width;
+            $h = $this->img->height;
+            $oldimg = $this->img->img;
+
+            $this->img->CreateImgCanvas(2*$w,2*$h);
+
+            $this->img->SetColor( $this->margin_color );
+            $this->img->FilledRectangle(0,0,2*$w-1,2*$h-1);
+
+            // Make all icons *2 i size since we will be scaling down the
+            // imahe to do the anti aliasing
+            $ni = count($this->iIcons);
+            for($i=0; $i < $ni; ++$i) {
+                $this->iIcons[$i]->iScale *= 2 ;
+                if( $this->iIcons[$i]->iX > 1 )
+                $this->iIcons[$i]->iX *= 2 ;
+                if( $this->iIcons[$i]->iY > 1 )
+                $this->iIcons[$i]->iY *= 2 ;
+            }
+
+            $this->StrokeIcons();
+
+            for($i=0; $i < $n; ++$i) {
+                if( $this->plots[$i]->posx > 1 )
+                $this->plots[$i]->posx *= 2 ;
+                if( $this->plots[$i]->posy > 1 )
+                $this->plots[$i]->posy *= 2 ;
+
+                $this->plots[$i]->Stroke($this->img,1);
+
+                if( $this->plots[$i]->posx > 1 )
+                $this->plots[$i]->posx /= 2 ;
+                if( $this->plots[$i]->posy > 1 )
+                $this->plots[$i]->posy /= 2 ;
+            }
+
+            $indent = $this->doframe ? ($this->frame_weight + ($this->doshadow ? $this->shadow_width : 0 )) : 0 ;
+            $indent += $this->framebevel ? $this->framebeveldepth + 1 : 0 ;
+            $this->img->CopyCanvasH($oldimg,$this->img->img,$indent,$indent,$indent,$indent,
+            $w-2*$indent,$h-2*$indent,2*($w-$indent),2*($h-$indent));
+
+            $this->img->img = $oldimg ;
+            $this->img->width = $w ;
+            $this->img->height = $h ;
+
+            for($i=0; $i < $n; ++$i) {
+                $this->plots[$i]->Stroke($this->img,2); // Stroke labels
+                $this->plots[$i]->Legend($this);
+            }
+
+        }
+        else {
+
+            if( !$_csim ) {
+                if( $this->background_image != "" ) {
+                    $this->StrokeFrameBackground();
+                }
+                else {
+                    $this->StrokeFrame();
+                    $this->StrokeBackgroundGrad();
+                }
+            }
+
+            $this->StrokeIcons();
+
+            for($i=0; $i < $n; ++$i) {
+                $this->plots[$i]->Stroke($this->img);
+                $this->plots[$i]->Legend($this);
+            }
+        }
+
+        $this->legend->Stroke($this->img);
+        $this->footer->Stroke($this->img);
+        $this->StrokeTitles();
+
+        if( !$_csim ) {
+
+            // Stroke texts
+            if( $this->texts != null ) {
+                $n = count($this->texts);
+                for($i=0; $i < $n; ++$i ) {
+                    $this->texts[$i]->Stroke($this->img);
+                }
+            }
+
+            if( _JPG_DEBUG ) {
+                $this->DisplayCSIMAreas();
+            }
+
+            // Should we do any final image transformation
+            if( $this->iImgTrans ) {
+                if( !class_exists('ImgTrans',false) ) {
+                    require_once('jpgraph_imgtrans.php');
+                    //JpGraphError::Raise('In order to use image transformation you must include the file jpgraph_imgtrans.php in your script.');
+                }
+
+                $tform = new ImgTrans($this->img->img);
+                $this->img->img = $tform->Skew3D($this->iImgTransHorizon,$this->iImgTransSkewDist,
+                $this->iImgTransDirection,$this->iImgTransHighQ,
+                $this->iImgTransMinSize,$this->iImgTransFillColor,
+                $this->iImgTransBorder);
+            }
+
+
+            // If the filename is given as the special "__handle"
+            // then the image handler is returned and the image is NOT
+            // streamed back
+            if( $aStrokeFileName == _IMG_HANDLER ) {
+                return $this->img->img;
+            }
+            else {
+                // Finally stream the generated picture
+                $this->cache->PutAndStream($this->img,$this->cache_name,$this->inline,
+                $aStrokeFileName);
+            }
+        }
     }
 } // Class
Index: trunk/client/modules/Elezioni/grafici/jpgraph_pie3d.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/jpgraph_pie3d.php	(revision 264)
+++ trunk/client/modules/Elezioni/grafici/jpgraph_pie3d.php	(revision 265)
@@ -1,57 +1,57 @@
 <?php
 /*=======================================================================
-// File:	JPGRAPH_PIE3D.PHP
-// Description: 3D Pie plot extension for JpGraph
-// Created: 	2001-03-24
-// Ver:		$Id: jpgraph_pie3d.php 956 2007-11-17 13:19:20Z ljp $
-//
-// Copyright (c) Aditus Consulting. All rights reserved.
-//========================================================================
-*/
+ // File:        JPGRAPH_PIE3D.PHP
+ // Description: 3D Pie plot extension for JpGraph
+ // Created:     2001-03-24
+ // Ver:         $Id: jpgraph_pie3d.php 1329 2009-06-20 19:23:30Z ljp $
+ //
+ // Copyright (c) Asial Corporation. All rights reserved.
+ //========================================================================
+ */
 
 //===================================================
 // CLASS PiePlot3D
-// Description: Plots a 3D pie with a specified projection 
+// Description: Plots a 3D pie with a specified projection
 // angle between 20 and 70 degrees.
 //===================================================
 class PiePlot3D extends PiePlot {
     private $labelhintcolor="red",$showlabelhint=true;
-    private $angle=50;	
+    private $angle=50;
     private $edgecolor="", $edgeweight=1;
     private $iThickness=false;
-	
-//---------------
-// CONSTRUCTOR
-    function PiePlot3d($data) {
-	$this->radius = 0.5;
-	$this->data = $data;
-	$this->title = new Text("");
-	$this->title->SetFont(FF_FONT1,FS_BOLD);
-	$this->value = new DisplayValue();
-	$this->value->Show();
-	$this->value->SetFormat('%.0f%%');
-    }
-
-//---------------
-// PUBLIC METHODS	
-	
+
+    //---------------
+    // CONSTRUCTOR
+    function __construct($data) {
+        $this->radius = 0.5;
+        $this->data = $data;
+        $this->title = new Text("");
+        $this->title->SetFont(FF_FONT1,FS_BOLD);
+        $this->value = new DisplayValue();
+        $this->value->Show();
+        $this->value->SetFormat('%.0f%%');
+    }
+
+    //---------------
+    // PUBLIC METHODS
+
     // Set label arrays
     function SetLegends($aLegend) {
-	$this->legends = array_reverse(array_slice($aLegend,0,count($this->data)));
+        $this->legends = array_reverse(array_slice($aLegend,0,count($this->data)));
     }
 
     function SetSliceColors($aColors) {
-	$this->setslicecolors = $aColors;
+        $this->setslicecolors = $aColors;
     }
 
     function Legend($aGraph) {
-	parent::Legend($aGraph);
-	$aGraph->legend->txtcol = array_reverse($aGraph->legend->txtcol);
+        parent::Legend($aGraph);
+        $aGraph->legend->txtcol = array_reverse($aGraph->legend->txtcol);
     }
 
     function SetCSIMTargets($aTargets,$aAlts='',$aWinTargets='') {
-	$this->csimtargets = $aTargets;
-	$this->csimwintargets = $aWinTargets;
-	$this->csimalts = $aAlts;
+        $this->csimtargets = $aTargets;
+        $this->csimwintargets = $aWinTargets;
+        $this->csimalts = $aAlts;
     }
 
@@ -59,12 +59,6 @@
     // will be used to separate pie slices.
     function SetEdge($aColor='black',$aWeight=1) {
-	$this->edgecolor = $aColor;
-	$this->edgeweight = $aWeight;
-    }
-
-    // Dummy function to make Pie3D behave in a similair way to 2D
-    function ShowBorder($exterior=true,$interior=true) {
-	JpGraphError::RaiseL(14001);
-//('Pie3D::ShowBorder() . Deprecated function. Use Pie3D::SetEdge() to control the edges around slices.');
+        $this->edgecolor = $aColor;
+        $this->edgeweight = $aWeight;
     }
 
